/*\
|*| --------------------------------------------------------------------------
|*|	Cirrus Logic I/O
|*| --------------------------------------------------------------------------
|*|
|*|	Copyright (C) 1997 by Martin Erhardsen [mee@daimi.aau.dk]
|*|
|*|	This program is free software; you can redistribute it and/or modify
|*|	it under the terms of the GNU General Public License as published by
|*|	the Free Software Foundation; either version 2, or (at your option)
|*|	any later version.
|*|
|*|	You should have received a copy of the GNU General Public License
|*|	along with this program; see the file COPYING.  If not, write to
|*|	the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
|*|
|*| ---------------------------------------------------------------------------
|*|
|*|     $Log: cl542xio.inc,v $
|*|     Revision 1.1  1997/12/28 14:18:57  martin
|*|     Added set_origin and set_splitline to my driver.
|*|
|*|     Revision 1.3  1997/12/09 10:11:35  seeger
|*|     Global cleanup for new include directory locations.
|*|
|*|     Revision 1.2  1997/09/05 09:59:19  martin
|*|     Added support for PCI and paged linear framebuffer in 542x driver
|*|
|*|     Revision 1.1  1997/06/27 13:44:59  martin
|*|     Ported my CL542x driver from GGI 0.0.8.
|*|
|*|
|*|
|*| ---------------------------------------------------------------------------
|*|	This code was derived from the following source of information:
|*|	[1]	XFree86 vga driver
\*/

/*\
|*|     GGI includes
\*/

#include "IBM/vga_io.inc"

#define NoSEQRegs	0x20
#define	NoCRTRegs	0x1C
#define NoGRCRegs	0x0F
#define NoATCRegs	0x15

struct statetable
{
   uint8 MISC;
   uint8 HDR;
   uint8 SEQ[NoSEQRegs];
   uint8 CRT[NoCRTRegs];
   uint8 GRC[NoGRCRegs];
   uint8 ATC[NoATCRegs];
};

#if 0
static void save_state(struct statetable *state)
{
	uint8 i,*buf;

	state->MISC=io_in8(MISCr);	/* save miscellaneous output reg */
	io_in8(0x3C6);io_in8(0x3C6);	/* Read 4 times */
	io_in8(0x3C6);io_in8(0x3C6); 
	state->HDR=io_in8(0x3C6);	/* Read value */
	io_in8(0x3C7);			/* Reset register */

	buf=state->SEQ;
	for(i = 0; i < NoSEQRegs; i++) *(buf++)=inbSEQ(i);
	buf=state->CRT;
	for(i = 0; i < NoCRTRegs; i++) *(buf++)=inbCRT(i);
	buf=state->GRC;
	for(i = 0; i < NoGRCRegs; i++) *(buf++)=inbGRC(i);
	buf=state->ATC;
	for(i = 0; i < NoATCRegs; i++) {
		io_in8(INS1r);  /* reset AFF and setup index */
		*(buf++)=inbATC(i);
	}
	io_in8(INS1r);
	io_out8( ATCI_ENABLEDISPLAY, ATCI);
}
#endif

static void restore_state(struct statetable *state)
{
	uint8 i,*buf;
	outbMISC((io_in8(MISCr) & MISC_CLOCK_MASK) | state->MISC);

	io_in8(0x3C6);io_in8(0x3C6);	/* Read 4 times */
	io_in8(0x3C6);io_in8(0x3C6); 
	io_out8(state->HDR,0x3C6);	/* Write value */

	buf=state->SEQ;
	for(i=0; i < NoSEQRegs; i++) outbSEQ(*(buf++),i);
	buf=state->CRT;
#if 1
	outbCRT(inbCRT(0x11) & ~0x80, 0x11);
	outbCRT(inbCRT(0x03) | 0x80,0x03);
	state->CRT[0x03] |= 0x80;
	state->CRT[0x11]  &= ~0x80;
#endif
	for(i = 0; i < NoCRTRegs; i++) outbCRT(*(buf++), i);
	buf=state->GRC;
	for(i=0; i < NoGRCRegs; i++) outbGRC(*(buf++),i);
	buf=state->ATC;
	for(i = 0; i < NoATCRegs; i++) {
		io_in8(INS1r);
		outbATC(*(buf++),i);
  	}
	io_in8(INS1r);
	io_out8(ATCI_ENABLEDISPLAY, ATCI);

}

#if defined(DEBUG_IO)||defined(DEBUG_STATE)
static void dump_state(struct statetable *state)
{ int i;
  printk("MISC: %.2x",state->MISC);
  
  for(i = 0; i < NoSEQRegs; i++)
   { if(!(i & 0xF)) printk("\nSEQ:%.2x: ",i); printk("%.2x, ",state->SEQ[i]); }
  for(i = 0; i < NoCRTRegs; i++)
   { if(!(i & 0xf)) printk("\nCRT:%.2x: ",i); printk("%.2x, ",state->CRT[i]); }
  for(i = 0; i < NoGRCRegs; i++)
   { if(!(i & 0xF)) printk("\nGRC:%.2x: ",i); printk("%.2x, ",state->GRC[i]); }
  for(i = 0; i < NoATCRegs; i++)
   { if(!(i & 0xF)) printk("\nATC:%.2x: ",i); printk("%.2x, ",state->ATC[i]); }
  printk("\n");
}
#endif














