/* --------------------------------------------------------------------------
 * Western Digital wd90c1x I/O
 * --------------------------------------------------------------------------
 *
 * Copyright (C) 1995 by The Linux-GGI Project
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Library General Public License as published 
 * by the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this program; see the file LGPL.  If not, write to
 * the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * ---------------------------------------------------------------------------
 *
 * Revision 0.2  1997/02/03 15:06:35  bri
 * Major: extracted wd90c1x+ functions from wd90c3x_io.inc
 *
 * ---------------------------------------------------------------------------
 * This code was derived from the following source of information:
 * [1]	XFree86 vga driver
 */

/* GGI includes */
#include "WD/wd90c1x_io.h"

static void save_SEQ(uint8 *buf)
{
  int i;
  uint8 lockreg;
  
  lockreg = inbSEQ(SEQ_UPSEQ_LOCK);
  outbSEQ(SR06_UNLOCK_UPSEQ,SEQ_UPSEQ_LOCK); 
  for (i = 0; i < NoSEQRegs ; i++) 
	{		
	  *(buf++) = inbSEQ(i);
	};
  outbSEQ(lockreg,SEQ_UPSEQ_LOCK); 
}

static void restore_SEQ(uint8 *buf)
{
  register uint8 i;
	uint8 lockreg = 0;  /* prevent gcc warnings */
	
	for (i = 0; i < NoSEQRegs ; i++) 
	  {
	    if (i == SEQ_UPSEQ_LOCK) {
	      lockreg = inbSEQ(SEQ_UPSEQ_LOCK);
	      outbSEQ(SR06_UNLOCK_UPSEQ,SEQ_UPSEQ_LOCK);
	      buf++;
	    } else { 
	      outbSEQ(*(buf++), i);
	    }; 
	  };
	outbSEQ(lockreg,SEQ_UPSEQ_LOCK); 
} 

