/*    
|*| ---------------------------------------------------------------------------
|*|	wd_probe -- probe for Western Digital (Paradise) chipsets
|*| ---------------------------------------------------------------------------
|*|
|*|	Copyright (C) 1997 by Brian S. Julin, <bri@calyx.com>
|*|
|*|	This header is free software; you can redistribute it and/or modify
|*|	it under the terms of the GNU Library General Public License as 
|*|	published by the Free Software Foundation; either version 2, or 
|*|     (at your option) any later version.
|*|
|*|	You should have received a copy of the GNU Library General Public 
|*|     License along with this program; see the file COPYING.LGPL.  
|*|	If not, write to the Free Software Foundation, 675 Mass Ave, 
|*|     Cambridge, MA 02139, USA.
|*| ---------------------------------------------------------------------------
\*/


#include <sys/perm.h>
#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>

#include "WD/wd_family.h"
#include "WD/wd90c1x.h"

unsigned short CRTI, CRTD, INS1r;
static char *wd_chipset_names[WD_HOWMANY_CHIPSETS] = { WD_VERBOSE_NAMES };

/* So as not to break includes */
char* chipset;

void main (void) {
  struct kgi_wd_chipset chipset;

  iopl(3);

  memset(chipset.revstring, 0, (CRT_CHIPREV6 - CRT_CHIPSIG1 + 2));

  kgi_chipset_wd_detect(&chipset);
  if (! chipset.revstring[0]) {
    strcpy(chipset.revstring, "N/A\0");
  } 
  printf("Detected Chipset %s (Revision info: %s)\n", 
	 wd_chipset_names[chipset.chiptype], chipset.revstring);

  kgi_chipset_wd_findram(&chipset);
  printf("%dKBytes RAM%s\n", chipset.chipset.ramsize / 1024,
	 ((chipset.features & BANKING_RAM) ? ", with banking" : ""));

}





