/* ---------------------------------------------------------------------------
**	AV 90C64 clocks (supposed to be used with Western Digital cards.)
** ---------------------------------------------------------------------------
**
**	Copyright (c)	1995-1997	Steffen Seeger
**
**	This program is free software; you can redistribute it and/or modify
**	it under the terms of the GNU General Public License as published by
**	the Free Software Foundation; version 2, or any later version.
**
**	You should have received a copy of the GNU General Public License
**	along with this program; see the file COPYING.  If not, write to
**	the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
** ---------------------------------------------------------------------------
**	derived from the AV9194/90C64 docs by ICS.
**
**	$Log: av90c64.c,v $
**	Revision 1.4  1997/11/08 15:12:36  becka
**	Namespace cleanup ... probably broke all and everything ...
**	
**	Revision 1.3  1997/10/03 11:25:00  seeger
**	minor:	added CVS logging, maintainer definition and standard headers.
**	
*/

#include <ggi/maintainers.h>
#define	MAINTAINER	Steffen_Seeger
#define	DRIVER_NAME	"AV 90C64 clock chip driver"
#define	DRIVER_REV	"$Revision: 1.4 $"

#include <ggi/module.h>

static struct kgi_clock clock =
{
	"Avasem",		/* manufacturer		*/
	"AV90C64",		/* model		*/
	GM_ALL,			/* supported modes	*/
	0,			/* special capabilities	*/
	{ 0x7FFF, 0x7FFF },	/* maximum resolution	*/


	CLK_TYPE_FIXED,		/* fixed clock values	*/

	/*	The clock values. Note that they have to be in descending
	**	order and that there must be no repetitions.
	*/

	{{
		80000000,	77250000,	75000000,	65000000,
		50000000,	50000000,	44900000,	40000000,
		36000000,	36000000,	32000000,	31500000,
		30000000,	28322000,	25175000,	0
	}}
};

/*
**	Driving CS[0:3] to clkindex[i] selects clock.clock.freq[i].
*/

static unsigned char clkindex[MAX_FIXED_CLOCKS] =
{	0x03, 0x01, 0x06, 0x0E,
	0x09, 0x07, 0x0B, 0x08,
	0x0F, 0x05, 0x0A, 0x04,
	0x00, 0x0D, 0x0C, 0xFF
};

static inline struct kgi_clock *init_clock (void)
{
	/*	no detection possible
	*/
	return &clock;
}

static inline void done_clock(void)
{
}

#include "fixed.inc"
