#include <IBM/vga.h>

#define	CRT_Ic	0x03D4		/* CRT Controller Index - Colour */
#define CRT_Im	0x03B4		/* CRT Controller Index - Mono */

#define CRT_Dc	0x03D5		/* CRT Controller Data Register - Colour */
#define CRT_Dm	0x03B5		/* CRT Controller Data Register - Mono */

#define ISR_1c	0x03DA		/* Input Status Register 1 - Colour */
#define ISR_1m	0x03BA		/* Input Status Register 1 - Mono */

#define SEQ_I	0x03C4		/* Sequencer Index */
#define SEQ_D	0x03C5		/* Sequencer Data Register */

#define SEQ_REGISTER_6	0x06	/* */
#define SEQ_REGISTER_A	0x0A	/* Memory Size */
#define SEQ_REGISTER_E	0x0E	/* VCLK3 Numerator */
#define SEQ_REGISTER_17	0x17	/* */
#define	SEQ_REGISTER_1E	0x1E	/* VCLK3 Denominator */

#define CRT_REGISTER_11	0x11	/* */
#define CRT_REGISTER_27 0x27	/* Chip ID register */

extern uint8 chip_version;
extern uint32 lin_adr;

/*\
|*| Chip version ID numbers
\*/

#define	CLGD5420_ID	0x88	/* 542x Series - ISA/VLB ? */
#define	CLGD5422_ID	0x8C
#define	CLGD5424_ID	0x94
#define CLGD5425_ID	0x80
#define	CLGD5426_ID	0x90
#define	CLGD5428_ID	0x98
#define	CLGD5429_ID	0x9C

#define	CLGD5430_ID	0xA0	/* 543x Series - PCI ? */
#define CLGD5434_ID	0xA8
#define CLGD5436_ID	0xAC

#define CLGD5446_ID	0xB8

#define CLGD5462_ID	0xD0
#define CLGD5464_ID	0xD4

/*\
|*| Cirrus bus types
\*/

#define	CIRRUS_BUS_UNKNOWN	0
#define CIRRUS_BUS_ISA		1
#define CIRRUS_BUS_VLB		2
#define CIRRUS_BUS_PCI		3

#ifdef CIRRUS_STRINGS

static char *
chip_strings [] =
	{
	"Cirrus Logic CL-GD5420",	/* CLDG5420 */
	"Cirrus Logic CL-GD5422",	/* CLDG5422 */
	"Cirrus Logic CL-GD5426",	/* CLDG5426 */
	"Cirrus Logic CL-GD5424",	/* CLDG5424 */
	"Cirrus Logic CL-GD5428",	/* CLDG5428 */
	"Cirrus Logic CL-GD5429",	/* CLDG5429 */
	"Cirrus Logic CL-GD5430",	/* CLDG5430 */
	"",
	"Cirrus Logic CL-GD5434",	/* CLDG5434 */
	"Cirrus Logic CL-GD5436",	/* CLDG5436 */
	"",
	"",
	"Cirrus Logic CL-GD5446",	/* CLGD5446 */
	"",
	"",
	"",
	"",
	"",
	"Cirrus Logic CL-GD5462",	/* CLGD5462 */
	"Cirrus Logic CL-GD5464",	/* CLGD5464 */
	} ;

static char *
bus_strings [ 4 ] =
	{
	"UNKNOWN",
	"ISA",
	"VLB",
	"PCI"
	} ;



/* --------------------------------------------------------------------------
**	PCI Stuff
** --------------------------------------------------------------------------
*/

static uint16 PCIDevice_id[] =
{
   CLGD5430_ID,
   CLGD5434_ID,
   CLGD5436_ID,
   CLGD5446_ID,
   CLGD5462_ID,
   CLGD5464_ID,
   0
};

#endif
