/*
** Mystique only register definitions. Assumes mga_common_regs.h has 
** been included!
*/
#ifndef _MGA1064_REGS_H_
#define _MGA1064_REGS_H_

/* FIFO registers */
#define DMA_PAD    (0x54>>2)

/* DAC Registers */
#define PALWTADD  (MGA_BASE1+0x3C00)
#define PALRDADD  (MGA_BASE1+0x3C03)
#define PALDATA   (MGA_BASE1+0x3C01)    /* Data for palette registers */
#define PIXRDMSK  (MGA_BASE1+0x3C02)    /* Palette RAM Mask */
#define X_DATAREG (MGA_BASE1+0x3C0A)    /* Data for the DAC registers */

#define DAC_MAX_REGS 0x50

#define XMULCTRL 0x19
        #define XMUL_DEPTH_MASK   0x7
        #define XMUL_GT8_PAL     0x0
        #define XMUL_GT15OVL_PAL 0x1
        #define XMUL_GT16_PAL    0x2
        #define XMUL_GT24_PAL    0x3
        #define XMUL_GT32_DIRPAL 0x4
        #define XMUL_GT16_SPLIT  0x5
        #define XMUL_GT32_SPLIT  0x6
        #define XMUL_GT32_PAL    0x7

#define XPIXCLKCTRL 0x1A
        #define PIX_CLK_SEL_MASK 0x3
        #define PIX_CLK_SEL_PCI  0x0
        #define PIX_CLK_SEL_PIX  0x1
        #define PIX_CLK_SEL_EXT  0x2

        #define PIX_CLK_DIS 0x4
        #define PIX_PLL_POWER 0x8

#define XMISCCTRL   0x1E
        #define DAC_POWER 0x1

        #define MFC_SEL_MASK 0x6
        #define MFC_SEL_VGA  0x0
        #define MFC_SEL_MAFC 0x2
        #define MFC_SEL_DIS  0x6 /* XFree86 default */

        #define VGA_8_DAC 0x8

        #define RAM_CS 0x10

#define XZOOMCTRL   0x38
        #define HZOOM_MASK 0x3
        #define HZOOM_1X   0x0
        #define HZOOM_2X   0x1
        #define HZOOM_4X   0x3

#define XPIXPLLAM   0x44
#define XPIXPLLAN   0x45
#define XPIXPLLAP   0x46
#define XPIXPLLBM   0x48
#define XPIXPLLBN   0x49
#define XPIXPLLBP   0x4A
#define XPIXPLLCM   0x4C
#define XPIXPLLCN   0x4D
#define XPIXPLLCP   0x4E

        #define PLL_S 0x18
        #define PLL_P 0x7
        #define PLL_N 0x7F
        #define PLL_M 0x1F
        /* PLL_LOCK, see below */

#define XPIXPLLSTAT 0x4F
        #define PIX_LOCK 0x40

#endif /* _MGA1064_REGS_H_ */
