/*\
|*| ---------------------------------------------------------------------------
|*|	Western Digital accel engine register definitions
|*| ---------------------------------------------------------------------------
|*|
|*|	Copyright (C) 1997 by Brian S. Julin, <bri@calyx.com>
|*|
|*|	This header is free software; you can redistribute it and/or modify
|*|	it under the terms of the GNU Library General Public License as 
|*|	published by the Free Software Foundation; either version 2, or 
|*|     (at your option) any later version.
|*|
|*|	You should have received a copy of the GNU Library General Public 
|*|     License along with this program; see the file COPYING.LGPL.  
|*|	If not, write to the Free Software Foundation, 675 Mass Ave, 
|*|     Cambridge, MA 02139, USA.
|*| ---------------------------------------------------------------------------
\*/

/* MAINTAINER	Brian S. Julin, <bri@calyx.com> */

#ifndef _wd_accel_h
#define _wd_accel_h

#define WDACC1 0x23C0
        #define AC1_REGBANK_MASK 0x00FF
        #define AC1_REGIDX_MASK  0x0F00
        #define AC1_SEQ_READ     0x1000
        #define AC1_INVALID      0x2000

#define WDACC2 0x23C2
        #define AC2_DATA_MASK    0x0FFF
        #define AC2_REGIDX_MASK  0xF000

/* Note trick -- regidx must be masked by either AC1_REGIDX_MASK 
   or AC2_REG_IDX_MASK depending whether read or write */
        #define AC_SYS_CTL 0x0000
                #define AC_IRQ_STAT 0x0000
                        #define AC_IRQ_ACTV 0x0001
                        #define AC_IRQ1_ACTV 0x0002
                        #define AC_IRQ2_ACTV 0x0004
                        #define AC_IRQ3_ACTV 0x0008
                        #define AC_IRQ4_ACTV 0x0010
                        #define AC_IRQ5_ACTV 0x0020
                        #define AC_IRQ6_ACTV 0x0040
                        #define AC_IRQ710_ACTV 0x0080
                        #define AC_IRQ7_ACTV 0x0100
                        #define AC_IRQ8_ACTV 0x0200
                        #define AC_IRQ9_ACTV 0x0400
                        #define AC_IRQ10_ACTV 0x0800

        #define AC_BLT1          0x0001
                #define BLT_CTL 0x0000
                        #define BLT_SOURCE_MASK   0x003
                        #define BLT_SOURCE_VIDMEM 0x000
                        #define BLT_SOURCE_IO32   0x002
                        #define BLT_IFMT_MASK 0x0c
                        #define BLT_IFMT_COLOR 0x00
                        #define BLT_IFMT_MONOC 0x04
                        #define BLT_IFMT_FILL  0x08
                        #define BLT_IFMT_MONOH 0x0c
                        #define BLT_DEST_MASK 0x30
                        #define BLT_DEST_VIDMEM 0x00
                        #define BLT_DEST_IO32 0x20
                        #define BLT_SOURCE_LIN 0x40
                        #define BLT_DEST_LIN 0x80
                        #define BLT_MMODE_MASK 0x300
                        #define BLT_MMODE_PLAN 0x000
                        #define BLT_MMODE_PACK 0x100
                        #define BLT_ORIENT 0x400
                        #define BLT_START 0x800
/* Alternate layout for wd90c33 */
                        #define BLT33_SKIP_LAST 0x001
                        #define BLT33_SOURCE_MASK  0x002
                        #define BLT33_SOURCE_PAT 0x004
                        #define BLT33_IFMT_MASK 0x018
                        #define BLT33_IFMT_MONOC 0x008
                        #define BLT33_IFMT_FILL 0x010
                        #define BLT33_IFMT_MONOH 0x018
                        #define BLT33_DEST_MASK 0x020
                        #define BLT33_LINEDRAW 0x040
                        #define BLT33_YDIR 0x080
                        #define BLT33_XDIR 0x100
                        #define BLT33_DMODE_MASK 0xe00
                        #define BLT33_NOP 0x000
                        #define BLT33_BLTOP 0x200
                        #define BLT33_LSTRIP 0x400
                        #define BLT33_TRAPZ 0x600
                        #define BLT33_BRES 0x100


                #define BLT_CTL2 0x1100
/* not wd90c33 */
                        #define BLT_DEST_T 0x001
                        #define BLT_0RSRVD 0x002
                        #define BLT_NO_TPIX 0x004
                        #define BLT_MONO_T 0x008
                        #define BLT_PATT_MASK 0x030
                        #define BLT_NOT_PATT 0x000
                        #define BLT_PATT 0x010
                        #define BLT_REG_UPDATE 0x040
                        #define BLT_QSTART 0x080
                        #define BLT_YLINE_DIR 0x100
                        #define BLT_LINE_YMAJR 0x200
                        #define BLT_ISS_IRQ 0x400
                        #define BLT_LINE 0x800
/* wd90c33 */
                        #define BLT33_XP_MASK 0x007
                        #define BLT33_XP_2BIT 0x002
                        #define BLT33_XP_4BIT 0x003
                        #define BLT33_XP_8BIT 0x004
                        #define BLT33_XP_8OR16BIT 0x005
                        #define BLT33_PORT_MEM 0x008
                        #define BLT33_EMPTY_BUF 0x040
                        #define BLT33_MONO_TSRC 0x080
                        #define BLT33_T_POL 0x100
                        #define BLT33_T_ON  0x200
                        #define BLT33_DEPTH_MASK 0xC00
                        #define BLT33_DEPTH_4BPP 0x000
                        #define BLT33_DEPTH_8BPP 0x400
                        #define BLT33_DEPTH_16BPP 0x800

                #define BLT_SRCADD_LOW 0x2200
                #define BLT33_SRCADD_X 0x2200
                #define BLT_SRCADD_HI  0x3300
                        #define BLT_ADD_HIMASK 0x0FF
                #define BLT33_SRCADD_Y 0x3300
                #define BLT_DESTADD_LOW 0x4400
                #define BLT33_DESTADD_X 0x4400
                #define BLT_DESTADD_HI 0x5500
                #define BLT33_DESTADD_Y 0x5500
                #define BLT_DESTLEN_X 0x6600
                #define BLT_DESTLEN_Y 0x7700
                #define BLT_ROWPITCH 0x8800
                #define BLT33_ROP 0x8800
                #define BLT_ROP 0x9900
                        #define BLT_ROP_MASK  0xF00
                        #define BLT_ROP_FALSE 0x000
                        #define BLT_ROP_AND   0x100
                        #define BLT_ROP_SAND  0x200
                        #define BLT_ROP_SRC   0x300
                        #define BLT_ROP_NSAD  0x400
                        #define BLT_ROP_DST   0x500
                        #define BLT_ROP_XOR   0x600
                        #define BLT_ROP_OR    0x700
                        #define BLT_ROP_NOR   0x800
                        #define BLT_ROP_XNOR  0x900
                        #define BLT_ROP_NDEST 0xA00
                        #define BLT_ROP_SOND  0xB00
                        #define BLT_ROP_NSRC  0xC00
                        #define BLT_ROP_NSOD  0xD00
                        #define BLT_ROP_NAND  0xE00
                        #define BLT_ROP_TRUE  0xF00
                
                #define BLT_FG_COLOR 0xAA00
                #define BLT_BG_COLOR 0xBB00
                #define BLT_T_COLOR 0xCC00
                #define BLT_T_CMASK 0xDD00
                #define BLT_CMASK 0xEE00
                        #define BLT_COLOR_MASK 0x00F

                #define BLT33_LEFT_CLIP 0x9900
                #define BLT33_RIGHT_CLIP 0xAA00
                #define BLT33_TOP_CLIP 0xBB00
                #define BLT33_BOT_CLIP 0xCC00
                #define BLT33_BLOCK_IDX 0xFF00

        #define AC_HWCURS        0x0002
                #define HWC_CTL 0x0000
                        #define HWC_24BPP 0x010 /* wd90c33 only */
                        #define HWC_CMODE_MASK 0x0E0
                        #define HWC_MONO 0x000
                        #define HWC_2C_INV 0x020
                        #define HWC_2C_SINV 0x040
                        #define HWC_3C 0x060
                        #define HWC_PLANE_PROT 0x100
                        #define HWC_PATT_MASK 0x600
                        #define HWC_32X32 0x000
                        #define HWC_64X64 0x200
                        #define HWC_ENAB
                #define HWC_PATADDR_LOW 0x1100
                #define HWC_PATADDR_HI 0x2200
                        #define HWC_ADD_HIMASK 0x0FF
                #define HWC_PCOLOR 0x3300
                        #define HWC_COLOR_MASK 0x0FF
                #define HWC_HOTSPOT 0x5500
                        #define HWC_HOTX_MASK 0x03F
                        #define HWC_HOTY_MASK 0xFC0
                #define HWC_XPOS 0x6600
                #define HWC_YPOS 0x7700
                        #define HWC_POS_MASK 0x7FF
                #define HWC_ACOLOR 0x8800

                #define HWC33_PCOLOR_MID 0x4400
                #define HWC33_PCOLOR_HI 0x5500
                #define HWC33_SCOLOR_LOW 0x6600
                #define HWC33_SCOLOR_MID 0x7700
                #define HWC33_SCOLOR_HI 0x8800
                #define HWC33_ACOLOR_LOW 0x9900
                #define HWC33_ACOLOR_MID 0xAA00
                #define HWC33_ACOLOR_HI 0xBB00
                #define HWC33_HOTSPOT 0xCC00
                #define HWC33_XPOS 0xDD00
                #define HWC33_YPOS 0xEE00
                #define HWC33_BLOCK_IDX 0xFF00

        #define AC_BLT2          0x0003
                #define BLT2_MAP_BASE 0x0000
                #define BLT2_ROWPITCH 0x1100
                #define BLT2_FG0_COLOR 0x2200
                #define BLT2_FG1_COLOR 0x3300
                #define BLT2_BG0_COLOR 0x4400
                #define BLT2_BG1_COLOR 0x5500
                #define BLT2_T0_COLOR 0x6600
                #define BLT2_T1_COLOR 0x7700
                #define BLT2_T0_MASK 0x8800
                #define BLT2_T1_MASK 0x9900
                #define BLT2_MASK_LOW 0xAA00
                #define BLT2_MASK_HI 0xBB00
                #define BLT2_BLOCK_IDX 0xFF00

#define ACC_BLTIO 0x23C4
#define ACC_BRES1 0x23C8
#define ACC_BRES2 0x23CA
#define ACC_BRESE 0x23CC
#define ACC_CMD_BUF 0x23CE
        #define ACB_QIDX_MASK 0x007
        #define ACB_ENAB 0x020
        #define ACB_OFLOW 0x040
        #define ACB_BUSY 0x080
        #define ACB_ISS_IRQ 0x100
        #define ACB_IRQ_STAT 0x200
        #define ACB_VRET_IRQ 0x400

#endif /* defined _wd_accel_h */





