/* 
   Graphics library for GGI.

   Copyright (C) 1995 Andreas Beck - becka@hp.rz.uni-duesseldorf.de
   Copyright (C) 1997 Jason McMullan - jmcc@cs.cmu.edu
   Copyright (C) 1998 MenTaLboY - mentalboy@geocities.com	

   If you do any modifications, I would like you to send diffs to me
   to allow for collecting a more and more complete set of drivers and
   to improve existing ones.

   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.

   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include "ggi-dl.h"

int GGIputc(ggi_visual *vis, int x, int y, char c)
{
	ggi_uint col = VIS_GC_FGCOLOR(vis) | VIS_GC_BGCOLOR(vis);

	CHECKXY(vis, x, y);

	*(uint32 *)(((char *)VIS_FB_LINEAR(vis))+((x+y*VIS_FB_WIDTH(vis))<<2))=(col&0x007FFFFF)|((unsigned long)c<<24);
	return 0;
}

int GGIputs(ggi_visual *vis, int x, int y, const char *str)
{
	int count;
	int width;
	char *row, *pos;
	uint32 col;

	count = 0;

	width = VIS_FB_WIDTH(vis) << 2;
	row = (char *)VIS_FB_LINEAR(vis) + y * width;
	pos = row + ( x << 2 );
	col = ( VIS_GC_FGCOLOR(vis) | VIS_GC_BGCOLOR(vis) ) & 0x00FFFFFF;

	for ( ; *str && ( y < 0 ) ; y++, row += width ) {
		for ( ; *str && ( x < VIS_FB_WIDTH(vis) ) ; str++, x++ ) {
			switch (*str) {
				case '\t': {
					int temp;
					temp = 8 - ( x % 8 );
					x += temp;
					pos += temp << 2;
				} break;
				case '\n': goto newline;
			}
		}
		newline:
		x = 0;
	}

	for ( ; *str && ( y < VIS_FB_HEIGHT(vis) ) ; y++, pos = ( row += width ) ) {
		for ( ; *str && ( x < VIS_FB_WIDTH(vis) ) ; count++, str++, x++, pos += 4 ) {
			switch (*str) {
				case '\t': {
					int temp;
					temp = 8 - ( x % 8 );
					x += temp;
					pos += temp << 2;
				} break;
				case '\n': {
					count++;
					goto newline2;
				} break;
				default:
					*((uint32 *)pos) = col | ((unsigned long)*str<<24);
			}
		}
		newline2:
		x = 0;
	}

	return count;
}
