/* Attach a new stack to a substack-type handler.
 * Before==NULL means at the end.
 * Returns number of stack that was attached. <0 = error.
 */
static int attach_ev_stack(evstack *whereto,evstack *what,evstack *before)
{
	int x,y;
	STACKTYPEDEF *subs=whereto->private;
  
	if (subs->substacks[MAXSUBSTACK-1]) 
		return -ENOMEM;		/* Stack is full. */

	for(x=0;x<MAXSUBSTACK&&subs->substacks[x];x++)
	{
		if (subs->substacks[x]==before) break;
	}
  
	if (x>=MAXSUBSTACK || subs->substacks[x]!=before) 
  		return -EINVAL;		/* before is not valid */

	for(y=MAXSUBSTACK-1;y>x;y--)	/* Move the tail of the chain */
	{
		subs->substacks[y]=subs->substacks[y-1];
	}

	subs->substacks[x]=what;

	return x;
}

/* Detach a new stack from a substack-type handler.
 */
static int detach_ev_stack(evstack *whereto,evstack *what)
{
	int x,y;
	STACKTYPEDEF *subs=whereto->private;

	for(x=0;x<MAXSUBSTACK&&subs->substacks[x];x++)
	{
		if (subs->substacks[x]==what) break;
	}
  
	if (x>=MAXSUBSTACK || subs->substacks[x]!=what) 
		return -EINVAL;		/* stack not in there is not valid */

	y=x;
	for(x++;x<MAXSUBSTACK&&subs->substacks[x];x++)	/* Move the tail of the chain */
	{
		subs->substacks[x-1]=subs->substacks[x];
	}

	subs->substacks[x-1]=NULL;	/* Make sure the list is terminated right. */

	return y;
}
