/* stars.c		by Nathan Strong
 *
 * based on stars.bas, written by a friend of mine who goes by 'beek' in
 * the world of the internet :-) There is no copyright, no restrictions,
 * and most definitely no warranty on this software. I won't guarantee
 * that it will compile, or that it will not cause damage to your system
 * or your hardware. It's not like this is incredibly complicated code,
 * anyway, so it's your own fault for not checking the code first!
 *
 * You can do anything you want with this code. Use it in your next demo!
 * print it out and use it as wallpaper! Write me flamemail telling me how
 * much I suck at programming (my e-mail is gblues@gstis.net)!
 *
 * The only thing I ask is for credit, even if it's a "This portion
 * based on stars.c by Nathan Strong" buried deep in the source code
 * that nobody will ever see. I was nice enough to credit my friend beek
 * in the source, you can do the same for me :)
 *
 * You're still reading this? What's the matter with you? You must be
 * a lawyer or something :)
 */

/* Responsible for bad reformatting : <andreas.beck@ggi-project.org> */

#include<stdlib.h>
#include<stdio.h>
#include<unistd.h>
#include<time.h>
#include<math.h>
#include<ggi/libggi.h>

static ggi_visual_t *vis;
static ggi_pixel pallookup[256];
static ggi_mode mode;
static ggi_pixel black;
static int xoff, yoff;

static double angle = 0.0;

static int frames = 0;

static int stars[100][3];
static int starsr[100][3];
static int old[100][3];


void InitGraphics(void);
void InitStars(void);
void CleanUp(void);
void Transform(int *ta, int *tb);

int main(void) 
{
	int i;
	int x, y, oldx, oldy;
	double fps = 0.0;
	ggi_uint color = 0;
	time_t st = time(NULL);
	InitGraphics();
	InitStars();
	do	{
		for (i = 0; i < 100; i++)
		{
			old[i][0] = starsr[i][0];
			old[i][1] = starsr[i][1];
			old[i][2] = starsr[i][2];
	
			starsr[i][0] = stars[i][0];
			starsr[i][1] = stars[i][1];
			starsr[i][2] = stars[i][2];
	
			Transform(&starsr[i][1], &starsr[i][2]);
			Transform(&starsr[i][0], &starsr[i][2]);
			Transform(&starsr[i][0], &starsr[i][1]);

			oldx = (int) floor(((256*old[i][0])/(old[i][2]-1024))+xoff);
			oldy = (int) floor(((256*old[i][1])/(old[i][2]-1024))+yoff);

			x = (int) floor(((256*starsr[i][0])/(starsr[i][2]-1024))+xoff);
			y = (int) floor(((256*starsr[i][1])/(starsr[i][2]-1024))+yoff);
		
			color = (ggi_uint) floor((starsr[i][2] + 721) / 5.5);

			if(mode.graphtype==GT_8BIT) {
				ggiPutPixel(vis, oldx, oldy, 0);
				ggiPutPixel(vis, x, y, color);
			}
			else {
				ggiPutPixel(vis, oldx, oldy, black);
				ggiPutPixel(vis, x, y, pallookup[color]);
			}				
		}
		usleep(10000);
		ggiFlush(vis);
		frames++;
		angle += 0.5;
	} while(!ggiKeyPoll(vis));

	if ((time(NULL) - st) != 0)
		fps = frames / (time(NULL) - st);
	printf("%f frames per second\n", fps);
	printf("beek / lightspeed\n\nPorted to GGI by Nathan Strong\n");
	CleanUp();
	return 0;
}

void Transform(int *ta, int *tb)
{
	double y = 0.0, z = 0.0;
	y = (cos((angle / 20)) * *ta) - (sin((angle / 20)) * *tb);
	z = (sin((angle / 20)) * *ta) + (cos((angle / 20)) * *tb);
	*ta = (int) floor(y);
	*tb = (int) floor(z);
}

void CleanUp(void) 
{
	ggiClose(vis);
	ggiExit();
	exit(0);
}

void InitStars(void) 
{
	int i;
	srand(time(NULL));
	for (i = 0; i < 100; i++)
	{
		stars[i][0] = ((rand() % 320)+1 - 160) * 3;
		stars[i][1] = ((rand() % 320)+1 - 160) * 3;
		stars[i][2] = ((rand() % 128)+1 - 64) * 5;
	}
}

void InitGraphics(void) 
{
	ggi_color Palette[256];
	int i;

	if (ggiInit() != 0) {
		fprintf(stderr, "unable to initialize libggi, exiting.\n");
		exit(1);
	}
	if ((vis=ggiOpen(NULL)) == NULL) {
		fprintf(stderr,
			"unable to open default visual, exiting.\n");
		exit(1);
	}

	ggiSetInfoFlags(vis, GGIFLAG_ASYNC);
	ggiSetGraphMode(vis, GGI_AUTO, GGI_AUTO, GGI_AUTO, GGI_AUTO , GGI_AUTO);

	ggiGetMode(vis, &mode);
	xoff = mode.virt.x/2;
	yoff = mode.virt.y/2;

	for (i = 0; i < 256; i++)
	{
		Palette[i].r = i * 256;
		Palette[i].g = i * 256;
		Palette[i].b = i * 256;
		if (mode.graphtype!=GT_8BIT)
			pallookup[i] = ggiMapColor(vis, Palette+i);
	}

	if(mode.graphtype==GT_8BIT) {
		ggiSetPaletteVec(vis, 0, 256, Palette);
	}
	black = ggiMapColor(vis, Palette);
		
	ggiFillscreen(vis);
}
