/* 
 *	(c) 1997 Andreas Beck becka@sunserver1.rz.uni-duesseldorf.de
 * ------------------------------------------------------------------------
 *
 *	This program is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU Library General Public License as 
 *	published by the Free Software Foundation; either version 2, or 
 *	(at your option) any later version.
 * 
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU Library General Public License for more details.
 *
 *	You should have received a copy of the GNU Library General Public 
 *	License	along with this program; see the file COPYING.LGPL .  
 *	If not, write to the Free Software Foundation, 675 Mass Ave, 
 *	Cambridge, MA 02139, USA.
 *
 * ------------------------------------------------------------------------
 */ 

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/keysym.h>

#if defined(__CYGWIN32__) || defined (_AIX)
#define NO_SHM
#endif

#ifndef NO_SHM
#include <sys/ipc.h>
#include <sys/shm.h>
#include <X11/extensions/XShm.h>
#endif

#if defined(__osf__) && !defined(XShmQueryExtension)
extern int XShmQueryExtension(Display *);
#endif

#include "ggi-dl.h"

#define MANSYNC_CHILD
#define MANSYNC_ISASYNC (((struct Xhooks *)VIS_PRIVATE(vis))->isasync)
#define MANSYNC_DOFLUSH _GGIdoflush(xhk)

#ifdef MANSYNC_CHILD
#define MANSYNC_CHILDPID (((struct Xhooks *)VIS_PRIVATE(vis))->syncpid)
#define MANSYNC_OLDHANDLER (((struct Xhooks *)VIS_PRIVATE(vis))->oldsynchandler)
#endif


struct Xhooks { 
	Display *display;
	XImage *ximage;
#ifndef NO_SHM
	XShmSegmentInfo shminfo;               /* Segment info.  */
	int have_shm;
#endif
	Colormap cmap;
	int cmap_first,cmap_last;
	Window window;
	int xoff,yoff;       /* We can pan, too */
	int ysplit;          /* Emulating Splitline ;-) */
	GC gc;
	int screen;
	int XLibLock;        /* SpinLock would probably be more secure, but ... */
	int        nocols;   /* Number of colors in the colormap */
	ggi_color *colormap;
	int viswidth, visheight;
	int  isasync;
#ifdef MANSYNC_CHILD
	int  syncpid;
	void (*oldsynchandler) (int);
#endif
	int  relptr;
	sint16 oldmousex;
	sint16 oldmousey;
	uint8 relptr_keymask;
};

#define XLIB_PRIV(vis) ((struct Xhooks *)VIS_PRIVATE(vis))

#define RELPTR_KEYS { XK_Control_L, XK_Alt_L, 'm' }
#define RELPTR_KEYINUSE (1 | (1<<1) | (1<<2))
#define RELPTR_NUMKEYS  3

