/* 
   Graphics library for GGI.

   Copyright (C) 1998 Marcus Sundberg - marcus@ggi-project.org

   If you do any modifications, I would like you to send diffs to me
   to allow for collecting a more and more complete set of drivers and
   to improve existing ones.

   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.

   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include "ggi-dl.h"
#include "Xvisual.h"

int GGIputc(ggi_visual *vis,int x,int y,char c)
{
	XDrawString(XLIB_PRIV(vis)->display,
				XLIB_PRIV(vis)->window,
				XLIB_PRIV(vis)->gc,
				x,y+8,&c,1);
	
	XLIB_DOSYNC(vis);
	return EOK;
}

int GGIputs(ggi_visual *vis,int x,int y,const char *str)
{
	int rc=0;
	
	while(*str) {
		ggiPutc(vis,x,y,*str++);
		rc++;
		if ((x+=8)>=VIS_FB_WIDTH(vis)) {
			x=0;y+=8;
		}
	}
	
	return rc;
}

