/* 
   Graphics library for GGI. Mode management.

   Copyright (C) 1998 Andreas Beck - andreas.beck@ggi-project.org

   If you do any modifications, I would like you to send diffs to me
   to allow for collecting a more and more complete set of drivers and
   to improve existing ones.

   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.

   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <dlfcn.h>
#include <fcntl.h>
#include <errno.h>
#include <sys/ioctl.h>
#include <sys/mman.h>

#include "ggi-dl.h"
#include "internal.h"
#include "debug.h"
#include "SubVisual.h"
#include <ggi/ggi_commands.h>

int GGIsetmode(ggi_visual *vis,ggi_mode *tm)
{ 
	SubHook *subinfo=VIS_PRIVATE(vis);
	subinfo->position.x=tm->visible.x;
	subinfo->position.y=tm->visible.y;
	subinfo->botright.x=tm->virt.x+tm->visible.x;
	subinfo->botright.y=tm->virt.y+tm->visible.y;

	return 0;
}

/**********************************/
/* check any mode (text/graphics) */
/**********************************/
int GGIcheckmode(ggi_visual *vis,ggi_mode *tm)
{
	return -1;
}

/************************/
/* get the current mode */
/************************/
int GGIgetmode(ggi_visual *vis,ggi_mode *tm)
{
	return -1;
}

int GGIflush(ggi_visual *vis)
{
	SubHook *hook=VIS_PRIVATE(vis);
	return ggiFlush(hook->parent);
}
