/* ------------------------------------------------------------------------
 *	blit32.c  - part of the TrueEmu target of GGI.
 * ------------------------------------------------------------------------
 *
 * 	Copyright (c) 1998  Andrew Apted  <andrew@ggi-project.org>
 *
 *	This library is free software; you can redistribute it and/or
 *	modify it under the terms of the GNU Library General Public
 *	License as published by the Free Software Foundation; either
 *	version 2, or (at your option) any later version.
 * 
 *	This library is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU Library General Public License for more details.
 *
 *	You should have received a copy of the GNU Library General
 *	Public License along with this library; see the file
 *	COPYING.LGPL.  If not, write to the Free Software Foundation,
 *	675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * ------------------------------------------------------------------------
 */

#include <stdio.h>
#include <stdlib.h>

#include <ggi/ggi.h>
#include <ggi/libggi.h>

#include "ggi-dl.h"
#include "internal.h"
#include "debug.h"

#include "trueemu.h"


/**************************************************
 ***
 ***  Blit functions for 32 bit BGR0 source
 ***
 **************************************************/


#define R_OFF  2
#define G_OFF  1
#define B_OFF  0

#define SRC_STEP  4


#include "genblit.c"


TrueemuBlits blit32_table =
{
	blit_b32_d0,
	blit_b24_d0,

	blit_b16_d0,
	blit_b16_d2_ev,
	blit_b16_d2_od,
	blit_b16_d4_ev,
	blit_b16_d4_od,
	
	blit_b8_d0,
	blit_b8_d2_ev,
	blit_b8_d2_od,
	blit_b8_d4_ev,
	blit_b8_d4_od,
	
	blit_b4_d0,
	blit_b4_d2_ev,
	blit_b4_d2_od,
	blit_b4_d4_ev,
	blit_b4_d4_od,
};
