/* 
   Graphics library for GGI. Copybox.

   Copyright (C) 1998 Marcus Sundberg - marcus@ggi-project.org
   Copyright (C) 1997 Jason McMullan - jmcc@cs.cmu.edu

   If you do any modifications, I would like you to send diffs to me
   to allow for collecting a more and more complete set of drivers and
   to improve existing ones.

   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.

   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include <string.h>

#include "ggi-dl.h"

int GGIcopybox(ggi_visual *vis,int x,int y,int w,int h,int nx,int ny)
{
	int linew=VIS_FB_WIDTH(vis);
	int line;

	/* Clipping */
	if (nx< (VIS_GC(vis)->cliptl.x)) {
		int diff=(VIS_GC(vis)->cliptl.x)-nx;
		nx+=diff;
		x +=diff;
		w -=diff;
	}
	if (nx+w>=(VIS_GC(vis)->clipbr.x)) {
		w=(VIS_GC(vis)->clipbr.x)-nx;
	}
	if (ny< (VIS_GC(vis)->cliptl.y)) {
		int diff=(VIS_GC(vis)->cliptl.y)-ny;
		ny+=diff;
		y +=diff;
		h -=diff;
	}
	if (ny+h>(VIS_GC(vis)->clipbr.y)) {
		h=(VIS_GC(vis)->clipbr.y)-ny;
	}

	/* If nothing to copy or the source leaves the virtual screen, bail out. */
	if (w<=0||h<=0||x<0||y<0||x+w>VIS_FB_WIDTH(vis)||y+h>VIS_FB_HEIGHT(vis))
		return EOK;
	
	if (ny < y) {
		obox=(uint8 *)(VIS_FB_LINEAR(vis))+y*linew+x;
		nbox=(uint8 *)(VIS_FB_LINEAR(vis))+ny*linew+nx;
		for (line=0;line<h;line++,obox+=linew,nbox+=linew)
			memmove(nbox,obox,w);
	} else {
		obox=(uint8 *)(VIS_FB_LINEAR(vis))+(y+h-1)*linew+x;
		nbox=(uint8 *)(VIS_FB_LINEAR(vis))+(ny+h-1)*linew+nx;
		for (line=0;line<h;line++,obox-=linew,nbox-=linew)
			memmove(nbox,obox,w);
	}
	return EOK;
}
