/* 
   Mystique userspace acceleration library (derived from linear_8.so)

   Copyright (C) 1995 Andreas Beck - becka@hp.rz.uni-duesseldorf.de
   Copyright (C) 1997 Jason McMullan - jmcc@cs.cmu.edu
   Copyright (C) 1997 Matthias Grimrath - m.grimrath@tu-bs.de

   Anyone is welcome to improve this lib and send diffs to Matthias.

   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.

   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/mman.h>

#include "ggi-dl.h"
#include <ggi/ggi_commands.h>

#include "mystique-8-15-16-32.h"

int GGIdbinit(ggi_visual *visual)
{
	ggi_directbuffer *db;

	if ( NULL== (db=malloc(sizeof(ggi_directbuffer))) ) 
	        return -ENOMEM;

	db->app_private=db->lib_private=db->drv_private=NULL;
       	db->layout=blPixelLinearBuffer;
       	db->buffer.pixellinearbuffer.read=
       	db->buffer.pixellinearbuffer.write=VIS_FB_LINEAR(visual);
       	db->buffer.pixellinearbuffer.page_size=0; /* FIXME. Find that out. */
       	db->buffer.pixellinearbuffer.access=1|2|4|8;
       	db->buffer.pixellinearbuffer.align=1;
       	db->buffer.pixellinearbuffer.swap=0;
       	db->buffer.pixellinearbuffer.write_mask=0xffffffff;
       	db->buffer.pixellinearbuffer.bpp=__bpp;
       	db->buffer.pixellinearbuffer.stride=VIS_FB_WIDTH(visual)*__bpp / 8;
       	db->buffer.pixellinearbuffer.origin.x=
       	db->buffer.pixellinearbuffer.origin.y=0;
       	db->buffer.pixellinearbuffer.size.x=VIS_FB_WIDTH(visual);
       	db->buffer.pixellinearbuffer.size.y=VIS_FB_HEIGHT(visual);
       	strcpy(db->buffer.pixellinearbuffer.colorstring,__dbname);
       	db->buffer.pixellinearbuffer.setup=__plb_setup;
	/* numpad and PADs missing ! FIXME ! */

       	db->next=VIS_DB(visual);
	VIS_DB(visual)=db;

	return 0;	/* Always succeed */
}

