/* 
   Mystique userspace acceleration library

   Copyright (C) 1997 Matthias Grimrath - m.grimrath@tu-bs.de

   Anyone is welcome to improve this lib and send diffs to me.
 
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.

   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include <string.h>

#include "ggi-dl.h"
#include "mystique-8-15-16-32.h"

int GGIdrawhline(ggi_visual *vis,int x,int y,int w)
{
	DPRINT("drawhline: fg=0x%.8x, x=%d, y=%d, width=%d\n",
	       VIS_GC_FGCOLOR(vis),x,y,w);

	ACC_ADDDATA(DMA_YDSTLEN, (y << 16) | 1);
	ACC_ADDDATA(DMA_FXBNDRY, ((x+w) << 16) | x);
	ACC_ADDDATA(DMA_FCOL, VIS_GC_FGCOLOR(vis));
	ACC_ADDDATA(DMA_DWGCTL | DMA_GO, TRAP | __blkmode | SOLID | ARZERO | 
		    SGNZERO | SHFTZERO | BOP_COPY | BLTMOD_BMONOLEF);
	
	return SYNC_FLUSH(vis);
}

int GGIdrawvline(ggi_visual *vis,int x,int y,int h)
{
	DPRINT("drawvline: fg=0x%.8x, x=%d, y=%d, height=%d\n",
	       VIS_GC_FGCOLOR(vis),x,y,h);

	ACC_ADDDATA(DMA_YDSTLEN, (y << 16) | h);
	ACC_ADDDATA(DMA_FXBNDRY, ((x+1) << 16) | x);
	ACC_ADDDATA(DMA_FCOL, VIS_GC_FGCOLOR(vis));
	ACC_ADDDATA(DMA_DWGCTL | DMA_GO, TRAP | __blkmode | SOLID | ARZERO | 
		    SGNZERO | SHFTZERO | BOP_COPY | BLTMOD_BMONOLEF);

	return SYNC_FLUSH(vis);
}

int GGIdrawline(ggi_visual *vis,int x1,int y1,int x2,int y2)
{
	DPRINT("drawline: fg=0x%.8x, x=1%d, y1=%d, x2=%d, y2=%d\n",
	       VIS_GC_FGCOLOR(vis),x1,y1,x2,y2);

	ACC_ADDDATA(DMA_XYEND, (y2 << 16) | x2);
	ACC_ADDDATA(DMA_XYSTRT, (y1 << 16) | x1);
	ACC_ADDDATA(DMA_FCOL, VIS_GC_FGCOLOR(vis));
	ACC_ADDDATA(DMA_DWGCTL | DMA_GO, AUTOLINE_CLOSE | ATYPE_RPL | SOLID | 
		    SHFTZERO | BOP_COPY | BLTMOD_BFCOL);
	
	return SYNC_FLUSH(vis);
}
