/* 
 *  Library internal declarations
 *
 *  Copyright (C) 1998 Thomas Tanner. See CREDITS for details.
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Library General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Library General Public License for more details.
 *
 *  You should have received a copy of the GNU Library General Public
 *  License along with this library; if not, write to the Free
 *  Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#ifndef _LIB_H_
#define _LIB_H_

#include "ggilib.h"

#define	pixel	uchar
#define	LFBADDR(vis,x,y) ((uchar *)GGI_FB_LINEAR(vis)+y*GGI_FB_BPL(vis)+x)
#define	MIX(col,ptr,alpha) ((col * alpha + *ptr * (GGI_MAX_ALPHA-alpha)) / GGI_MAX_ALPHA)

void	(*GGINAME(putPixel)[16])(ggi_visual_t vis, int x, int y, ggi_pixel col);
void	(*GGINAME(putPixel_a)[16])(ggi_visual_t vis, int x, int y, ggi_pixel col);
void	(*GGINAME(drawPixel)[16])(ggi_visual_t vis, int x, int y);
void	(*GGINAME(drawPixel_a)[16])(ggi_visual_t vis, int x, int y);
void	(*GGINAME(drawPixelA)[16])(ggi_visual_t vis, int x, int y, ggi_alpha alpha);
void	(*GGINAME(drawPixelA_a)[16])(ggi_visual_t vis, int x, int y, ggi_alpha alpha);
void	GGINAME(fillPixelA)(ggi_visual_t vis, int x, int y, ggi_alpha alpha);
void	GGINAME(fillPixelA_a)(ggi_visual_t vis, int x, int y, ggi_alpha alpha);

/*
void	(*GGINAME(line)[4])(ggi_visual_t vis, int x1, int y1, int x2, int y2);
void	(*GGINAME(linef)[4])(ggi_visual_t vis, ggi_float x1, ggi_float y1, ggi_float x2, ggi_float y2);
*/
void	GGINAME(drawHLine_NOOP)(ggi_visual_t vis, int x1, int x2, int y);
void	GGINAME(drawHLine_INVERT)(ggi_visual_t vis, int x1, int x2, int y);
void	GGINAME(hLine)(ggi_visual_t vis, int x1, int x2, int y);
void	GGINAME(hLine_a)(ggi_visual_t vis, int x1, int x2, int y);
void	GGINAME(scanline)(ggi_visual_t vis, int x1, int x2, int y);
void	GGINAME(scanline_a)(ggi_visual_t vis, int x1, int x2, int y);

void	GGINAME(vLine_SET)(ggi_visual_t vis, int x, int y1, int y2);
void	GGINAME(fillRect_SET)(ggi_visual_t vis, int x1, int y1, int x2, int y2);

#endif	/*_LIB_H_*/
