/* 
 *  arc drawing
 *
 *  Copyright (C) 1998 Thomas Tanner. See CREDITS for details.
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Library General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Library General Public License for more details.
 *
 *  You should have received a copy of the GNU Library General Public
 *  License along with this library; if not, write to the Free
 *  Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#include "lib.h"
#include "util.h"

#include <math.h>	

/*--------------------------------------------------------------------------*/

static void	drawArc(ggi_visual_t vis, int x, int y, uint a, uint b,
	    	   ggi_float startangle, ggi_float endangle, ggi_bool close)
{
	void 	(*drawPixel)(ggi_visual_t, int, int) = 
		GGI2D_FUNC(vis)->drawPixel;
	
#define	PLOT(x, y)	drawPixel(vis, x, y)

#include "template/arc.h"
}

static void	drawArc_st(ggi_visual_t vis, int x, int y, uint a, uint b,
	    	   ggi_float start, ggi_float end, ggi_bool close)
{
}

static void	drawArc_aa(ggi_visual_t vis, int x, int y, uint a, uint b,
	    	   ggi_float start, ggi_float end, ggi_bool close)
{
}

static void	drawArc_st_aa(ggi_visual_t vis, int x, int y, uint a, uint b,
	    	   ggi_float start, ggi_float end, ggi_bool close)
{
}

static void	fillArc(ggi_visual_t vis, int x, int y, uint a, uint b,
		   ggi_float startangle, ggi_float endangle)
{
	void 	(*scanline)(ggi_visual_t, int, int, int) =
		GGI2D_FUNC(vis)->scanline;
	void 	(*line)(ggi_visual_t,int, int, int, int) =
		GGI2D_FUNC(vis)->line;
	
#define SCANLINE(x1, x2, y)	scanline(vis, x1, x2, y)
#define LINE(x1, y1, x2, y2)	line(vis, x1, y1, x2, y2)
#define	FILL

#include "template/arc.h"
}

static void	fillArc_aa(ggi_visual_t vis, int x, int y, uint a, uint b,
		   ggi_float start, ggi_float end)
{
}

void	(*GGINAME(drawArc)[4])(ggi_visual_t vis, int x, int y, uint a, uint b,
	    	   ggi_float startangle, ggi_float endangle, ggi_bool close) =
{
	drawArc,
	drawArc_st,
	drawArc_aa,
	drawArc_st_aa
};

void	(*GGINAME(fillArc)[2])(ggi_visual_t vis, int x, int y, uint a, uint b,
		   ggi_float startangle, ggi_float endangle) =
{
	fillArc,
	fillArc_aa
};

/*----------------------------------------------------------------------*/
