/* 
 *  blit functions
 *
 *  Copyright (C) 1998 Thomas Tanner. See CREDITS for details.
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Library General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Library General Public License for more details.
 *
 *  You should have received a copy of the GNU Library General Public
 *  License along with this library; if not, write to the Free
 *  Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#include "lib.h"
#include "util.h"

/*----------------------------------------------------------------------*/

void	GGINAME(blit)(
		    ggi_visual_t dest, int dx, int dy,	
		    ggi_visual_t src, int sx, int sy, int width, int height)	
{
	ggi_color	col;
	ggi_pixel	last, cur, conv;
	int		x, y;
	
        if (width  < 0) { dx += width;  sx += width;  width  = -width; }
        if (height < 0) { dy += height; sy += height; height = -height; }
	ggiGetPixel(src, sx, sy, &last); last++;
	y = 0;
	while (height--) {
		x = 0;
		while (width--) {
			ggiGetPixel(src, sx + x, sy + y, &cur);
			if (cur != last) {
				last = cur;
				ggiUnmapPixel(src, cur, &col);
				conv = ggiMapColor(dest, &col);
			}
			ggiPutPixel(dest, dx + x, dy + y, conv);			
			x++;
		}
		y++;
	}
}

void	GGINAME(blitOp)(
		    ggi_visual_t dest, int dx, int dy, 
		    ggi_visual_t src1, ggi_visual_t src2, 
		    int sx, int sy, int width, int height, 
		    ggi_operator op)
{
}

void	GGINAME(stretchBlit)(   
		    ggi_visual_t dest, int dx, int dy, int dwidth, int dheight,
		    ggi_visual_t src, int sx, int sy, int swidth, int sheight)
{
}

void	GGINAME(stretchBlitOp)(	    
		    ggi_visual_t dest, 
		    int dx, int dy, int dwidth, int dheight,
		    ggi_visual_t src1, ggi_visual_t src2,
		    int sx, int sy, int swidth, int sheight,
		    ggi_operator op)
{
}

/*----------------------------------------------------------------------*/
