/* 
 *  horizontal line drawing
 *
 *  Copyright (C) 1998 Thomas Tanner. See CREDITS for details.
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Library General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Library General Public License for more details.
 *
 *  You should have received a copy of the GNU Library General Public
 *  License along with this library; if not, write to the Free
 *  Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#include "lib.h"
#include "util.h"

/*----------------------------------------------------------------------*/

static void	hLine(ggi_visual_t vis, int x1, int x2, int y)
{
	int	x;
	void	(*drawPixel)(ggi_visual_t, int, int) 
    		= GGI2D_FUNC(vis)->drawPixel;
    
	CLIPHLINE(vis, x1, x2, y, x);
	for (x = x1; x <= x2; x++) drawPixel(vis, x, y);
}

static void	hLine_st(ggi_visual_t vis, int x1, int x2, int y)
{
}

void	(*GGINAME(hLine)[2])(ggi_visual_t vis, int x1, int x2, int y) =
{
	hLine,
	hLine_st
};

/*----------------------------------------------------------------------*/
