/* 
 *  Library internal declarations
 *
 *  Copyright (C) 1998 Thomas Tanner. See CREDITS for details.
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Library General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Library General Public License for more details.
 *
 *  You should have received a copy of the GNU Library General Public
 *  License along with this library; if not, write to the Free
 *  Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#ifndef _LIB_H_
#define _LIB_H_

#include "ggilib.h"

void	GGINAME(drawPixels)(ggi_visual_t vis, ggi_coord coords[], uint count);
void	GGINAME(scanlines)(ggi_visual_t vis, ggi_scanline scanlines[], uint count);
void	GGINAME(drawLines)(ggi_visual_t vis, ggi_line lines[], uint count);
void	(*GGINAME(hLine)[2])(ggi_visual_t vis, int x1, int x2, int y);
void	(*GGINAME(vLine)[2])(ggi_visual_t vis, int x, int y1, int y2);
void	(*GGINAME(drawRect)[2])(ggi_visual_t vis, int x1, int y1, int x2, int y2);
void	GGINAME(fillRect)(ggi_visual_t vis, int x1, int y1, int x2, int y2);
void	(*GGINAME(line)[4])(ggi_visual_t vis, int x1, int y1, int x2, int y2);
void	(*GGINAME(linef)[4])(ggi_visual_t vis, ggi_float x1, ggi_float y1, ggi_float x2, ggi_float y2);
void	(*GGINAME(drawCircle)[4])(ggi_visual_t vis, int x, int y, uint r);
void	(*GGINAME(fillCircle)[2])(ggi_visual_t vis, int x, int y, uint r);
void	(*GGINAME(drawEllipse)[4])(ggi_visual_t vis, int x, int y, uint a, uint b);
void	(*GGINAME(fillEllipse)[2])(ggi_visual_t vis, int x, int y, uint a, uint b);
void	(*GGINAME(drawArc)[4])(ggi_visual_t vis, int x, int y, uint a, uint b,
	    	   ggi_float start, ggi_float end, ggi_bool close);
void	(*GGINAME(fillArc)[2])(ggi_visual_t vis, int x, int y, uint a, uint b,
		   ggi_float start, ggi_float end);
void	(*GGINAME(bezier)[4])(ggi_visual_t vis, int x1, int y1, int x2, int y2, 
			int x3, int y3, int x4, int y4);
void	(*GGINAME(trapezoid)[2])(ggi_visual_t vis, int xl1, int xr1, int y1, int xl2, int xr2, int y2);
void	(*GGINAME(triangle)[2])(ggi_visual_t vis, int x1, int y1, int x2, int y2, int x3, int y3);
void	(*GGINAME(drawPoly)[2])(ggi_visual_t vis, ggi_coord coords[], uint count);
void	(*GGINAME(fillPoly)[2])(ggi_visual_t vis, ggi_coord coords[], uint count);
void	(*GGINAME(fillPolys)[2])(ggi_visual_t vis, ggi_coord coords[], uint counts[], uint count);
void	GGINAME(blit)(
		    ggi_visual_t dest, int dx, int dy,	
		    ggi_visual_t src, int sx, int sy, int width, int height);
void	GGINAME(blitOp)(
		    ggi_visual_t dest, int dx, int dy, 
		    ggi_visual_t src1, ggi_visual_t src2, int sx, int sy, 
		    int width, int height, ggi_operator op);
void	GGINAME(stretchBlit)(		    
		    ggi_visual_t dest, int dx, int dy, int dwidth, int dheight, 
		    ggi_visual_t src, int sx, int sy, int swidth, int sheight);
void	GGINAME(stretchBlitOp)(		    
		    ggi_visual_t dest, 
		    int dx, int dy, int dwidth, int dheight,
		    ggi_visual_t src1, ggi_visual_t src2,
		    int sx, int sy, int swidth, int sheight,
		    ggi_operator op);

/*----------------------------------------------------------------------*/

#endif	/*_LIB_H_*/
