/* 
 *  line drawing
 *
 *  Copyright (C) 1998 Thomas Tanner. See CREDITS for details.
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Library General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Library General Public License for more details.
 *
 *  You should have received a copy of the GNU Library General Public
 *  License along with this library; if not, write to the Free
 *  Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#include "lib.h"
#include "util.h"

/*----------------------------------------------------------------------*/

static void	linef(ggi_visual_t vis, ggi_float x1, ggi_float y1, ggi_float x2, ggi_float y2)
{
	void 	(*drawPixel)(ggi_visual_t, int, int) 
	= GGI2D_FUNC(vis)->drawPixel;

#define HLINE(x1, x2, y)	GGI2D_FUNC(vis)->hLine(vis, x1, x2, y)
#define VLINE(x, y1, y2)	GGI2D_FUNC(vis)->vLine(vis, x, y1, y2)
#define PLOT(x, y)		drawPixel(vis, x, y)
#define FLOAT_COORDS

#include "template/line.h"
}

static void	linef_st(ggi_visual_t vis, ggi_float x1, ggi_float y1, ggi_float x2, ggi_float y2)
{
}

static void	linef_aa(ggi_visual_t vis, ggi_float x1, ggi_float y1, ggi_float x2, ggi_float y2)
{
	void 	(*drawPixel)(ggi_visual_t, int, int) 
		= GGI2D_FUNC(vis)->drawPixel;
	void 	(*drawPixelA)(ggi_visual_t, int, int, ggi_alpha) 
		= GGI2D_FUNC(vis)->drawPixelA;

#define HLINE(x1, x2, y)	GGI2D_FUNC(vis)->hLine(vis, x1, x2, y)
#define VLINE(x, y1, y2)	GGI2D_FUNC(vis)->vLine(vis, x, y1, y2)
#define PLOT(x, y)		drawPixel(vis, x, y)
#define PLOTA(x, y, alpha)	drawPixelA(vis, x, y, alpha)
#define ANTIALIAS
#define FLOAT_COORDS

#include "template/line.h"
}

static void	linef_st_aa(ggi_visual_t vis, ggi_float x1, ggi_float y1, ggi_float x2, ggi_float y2)
{
}

void	(*GGINAME(linef)[4])(ggi_visual_t vis, ggi_float x1, ggi_float y1, ggi_float x2, ggi_float y2) =
{
	linef,
	linef_st,
	linef_aa,
	linef_st_aa
};

/*----------------------------------------------------------------------*/
