/* 
 *  misc drawing functions
 *
 *  Copyright (C) 1998 Thomas Tanner. See CREDITS for details.
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Library General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Library General Public License for more details.
 *
 *  You should have received a copy of the GNU Library General Public
 *  License along with this library; if not, write to the Free
 *  Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#include "lib.h"
#include "util.h"

/*----------------------------------------------------------------------*/

void	GGINAME(scanlines)(ggi_visual_t vis, ggi_scanline scanlines[], uint count)
{
	int	i;
	void 	(*scanline)(ggi_visual_t, int, int, int) 
		= GGI2D_FUNC(vis)->scanline;
    
	for (i = 0; i < count; i++)
		scanline(vis, scanlines[i].x1, scanlines[i].x2, scanlines[i].y);
}

void	GGINAME(drawPixels)(ggi_visual_t vis, ggi_coord coords[], uint count)
{
	int	i;
	void 	(*drawPixel)(ggi_visual_t, int, int) 
		= GGI2D_FUNC(vis)->drawPixel;
    
	for (i = 0; i < count; i++)
		drawPixel(vis, coords[i].x, coords[i].y);
}

void	GGINAME(drawLines)(ggi_visual_t vis, ggi_line lines[], uint count)
{
	int	i;
	void 	(*line)(ggi_visual_t, int, int, int, int) 
		= GGI2D_FUNC(vis)->line;
    
	for (i = 0; i < count; i++)
		line(vis, lines[i].x1, lines[i].y1, lines[i].x2, lines[i].y2);
}

/*----------------------------------------------------------------------*/
