/* 
 *  GGI Utility library
 *
 *  Copyright (C) 1998 Uwe Maurer - uwe_maurer@t-online.de
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Library General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Library General Public License for more details.
 *
 *  You should have received a copy of the GNU Library General Public
 *  License along with this library; if not, write to the Free
 *  Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <internal.h>
#include <string.h>

int	_gwt_offset;

static int load(ggi_visual_t vis,const char *lib,const char *opt)
{
	char str[1024];
	gwt_extension_t *e;

	e=GWT(vis);

	if (strncmp(lib,"display",7)==0)
	{ 
		/* Initialize per-visual information here */
		e->winpos.x=e->winpos.y=0;
	}

	/* Now try to load a library for implementing GWT functionality. 
	 * I would suggest to load such a helper library for each "display-*".
	 * It will contain the necessary helper functions to associate
	 * window positions, z-order, ... for each target.
	 * E.g. display-X would call the appropriate X-window-functions.
	 */

	strcpy(str,lib);
	strcat(str,"-gwt");

	if (ggiLoadLibrary(vis,str,opt)) {
		printDEBUG("vis %i:  %s loaded!\n",(int) vis,str);
	}
	
	return 0;
}
static int unload(ggi_visual_t vis,const char *lib)
{
	return 0;
}

int gwtInit(void)
{
	ggiInit();

	_gwt_offset=ggiRegisterExtension(sizeof(gwt_extension_t),load,unload);

	return 0;
}

int gwtExit(void)
{
	ggiExit();
	return 0;
}

