/* Based on:
 * libGGI 1.2
 */

/* This file is included by mouse.c. */

#include <stdio.h>
#include "internal.h"

static int ms_init(void)
{
    return EVENT_FD;
}

/* Scooped from X driver. */
static inline void ms_close(void)
{
}

static int get_ms_event(int wait)
/*
   Changed to process multiple packets.
   wait value:
   0    Process any mouse events, and return status.
   1    Wait for mouse event, then return.

   Status indicates whether an event was processed.
 */
{
	ggi_event ev;
	ggi_event_mask em;
	int handled=0;
	static int x,y,buttons;
	struct timeval *tp,ztime={0,1};

	if (wait) 
		tp=NULL;
	else
		tp=&ztime;

	while (ggiEventPoll(MASTER_VIS,emPtrButton,&ztime)) {
		ggiEventRead(MASTER_VIS,&ev,emPtrButton);
				handled++;
				buttons=((ev.pbutton.state & 0x01)<<2); /*Left*/
				buttons|=((ev.pbutton.state & 0x02)>>1); /*Right*/
				buttons|=((ev.pbutton.state & 0x04)>>1); /*Middle*/
				__mouse_eventhandler(buttons,0,0,0,0,0,0);
	   
	}
	while (ggiEventPoll(MASTER_VIS,emPtrRelative,&ztime)) {
		ggiEventRead(MASTER_VIS,&ev,emPtrRelative);
				__mouse_eventhandler(buttons,ev.pmove.x,ev.pmove.y,ev.pmove.wheel,0,0,0);
				handled++;
				x+=ev.pmove.x;
				y+=ev.pmove.y;
	   break;
	}
	return handled;
}
